#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
void ATL_cJIK24x24x24TN0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=3, ku=4, pf=0
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const float *stM = A + (((lda) << 5)+((lda) << 4));
   const float *stN = B + (((ldb) << 5)+((ldb) << 4));
   #define incAk 8
   const int incAm = ((((lda) - 24) << 1)), incAn = -(((lda) << 5)+((lda) << 4));
   #define incBk 8
   const int incBm = -48, incBn = (((ldb) << 2)+((ldb) << 1));
   const int incAk0 = ((incAk) >> 2), incBk0 = ((incBk) >> 2);
   #define incCm 2
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 48;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1));
   register int k;
   register float rA0;
   register float rB0, rB1, rB2;
   register float m0, m1;
   register float rC0_0, rC0_1, rC0_2;
   do /* N-loop */
   {
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_0 = rC0_1 = rC0_2 = 0.0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rB1 = *pB1;
         m1 = rA0 * rB1;
         rB2 = *pB2;

         for (k=20; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB1[2];
            rC0_1 += m1;
            m1 = rA0 * rB0;
            rB2 = pB2[2];
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA0 * rB2;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB1[4];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rB2 = pB2[4];
            rC0_2 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rB1 = pB1[6];
            rC0_1 += m1;
            m1 = rA0 * rB0;
            rB2 = pB2[6];
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC0_0 += m1;
            m1 = rA0 * rB2;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rB1 = pB1[8];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rB2 = pB2[8];
            rC0_2 += m1;
            m1 = rA0 * rB1;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rC0_1 += m1;
         m1 = rA0 * rB0;
         rB2 = pB2[2];
         rC0_2 += m0;
         m0 = rA0 * rB1;
         rC0_0 += m1;
         m1 = rA0 * rB2;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rB2 = pB2[4];
         rC0_2 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rC0_1 += m1;
         m1 = rA0 * rB0;
         rB2 = pB2[6];
         rC0_2 += m0;
         m0 = rA0 * rB1;
         pA0 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
         pB1 += (((incBk0) << 1)+incBk0);
         pB2 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m1;
         m1 = rA0 * rB2;
         rC0_1 += m0;
         rC0_2 += m1;
         pA0 += incAk0;
         pB0 += incBk0;
         pB1 += incBk0;
         pB2 += incBk0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
