#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK36x4x36NT1x4x1_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=36, NB=4, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 36;
   const double *stN = B + 4;
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 5)+((lda) << 2)), incAn = -36;
   const int incBk = (ldb), incBm = -(((ldb) << 5)+((ldb) << 2));
   #define incBn 4
   #define incCm 1
   const int incCn = (((ldc) << 2)) - 36;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC0_1, rC0_2, rC0_3;
   do /* M-loop */
   {
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC0_0 = rA0 * rB0;
      rC0_1 = rA0 * rB1;
      rC0_2 = rA0 * rB2;
      rC0_3 = rA0 * rB3;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=35; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rC0_0 += rA0 * rB0;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK36x36x36NT0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=36, NB=36, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 36;
   const double *stN = B + 32;
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 5)+((lda) << 2)), incAn = -36;
   const int incBk = (ldb), incBm = -(((ldb) << 5)+((ldb) << 2));
   #define incBn 8
   #define incCm 1
   const int incCn = (((ldc) << 3)) - 36;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         ATL_pfl1W(pC6);
         ATL_pfl1W(pC7);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rB4 = pB0[4];
         rB5 = pB0[5];
         rB6 = pB0[6];
         rB7 = pB0[7];
         rC0_0 = rA0 * rB0;
         rC0_1 = rA0 * rB1;
         rC0_2 = rA0 * rB2;
         rC0_3 = rA0 * rB3;
         rC0_4 = rA0 * rB4;
         rC0_5 = rA0 * rB5;
         rC0_6 = rA0 * rB6;
         rC0_7 = rA0 * rB7;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=35; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[1];
            rB2 = pB0[2];
            rB3 = pB0[3];
            rB4 = pB0[4];
            rB5 = pB0[5];
            rB6 = pB0[6];
            rB7 = pB0[7];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC0_6 *= rB0;
         rC0_7 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK36x4x36NT1x4x1_aX_b0(36, 4, 36, alpha, ca, lda, cb + 32, ldb, beta, cc + (((ldc) << 5)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
