#ifdef ATL_UCLEANM
#define ATL_dJIK0x48x48TN48x48x0_a1_b0 ATL_dgpMBmm_b0
#else
#define ATL_dJIK0x48x48TN48x48x0_a1_b0 ATL_dpMBmm_b0
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK0x48x48TN48x48x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=8, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2304;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*8)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 384;
   #define incCm 1
   const int incCn = (((ldc) << 3)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc), *pC7=pC6+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         ATL_pfl1W(pC6);
         ATL_pfl1W(pC7);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[48];
         rB2 = pB0[96];
         rB3 = pB0[144];
         rB4 = pB0[192];
         rB5 = pB0[240];
         rB6 = pB0[288];
         rB7 = pB0[336];
         rC0_0 = rA0 * rB0;
         rC0_1 = rA0 * rB1;
         rC0_2 = rA0 * rB2;
         rC0_3 = rA0 * rB3;
         rC0_4 = rA0 * rB4;
         rC0_5 = rA0 * rB5;
         rC0_6 = rA0 * rB6;
         rC0_7 = rA0 * rB7;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=47; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[48];
            rB2 = pB0[96];
            rB3 = pB0[144];
            rB4 = pB0[192];
            rB5 = pB0[240];
            rB6 = pB0[288];
            rB7 = pB0[336];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
